%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define copying() \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7 \
%license %{*} \
%else \
%doc %{*} \
%endif

%global provider        google
%global provider_sub    code
%global provider_tld    com
%global project         p
%global repo            go-decimal-inf
%global provider_prefix code.google.com/p/go-decimal-inf
%global import_path     speter.net/go/exp/math/dec/inf
%global rev             42ca6cd68aa922bc3f32f1e056e61b65945d9ad7
%global shortrev        %(r=%{rev}; echo ${r:0:12})

Name:           golang-%{provider}%{provider_sub}-%{repo}
Version:        0
Release:        0.3.hg%{shortrev}%{?dist}
Summary:        Package implementing "infinite-precision" decimal arithmetic
License:        BSD
URL:            https://%{import_path}
Source0:        https://exp.go-decimal-inf.%{provider}%{provider_sub}.%{provider_tld}/archive/%{rev}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%description
Package inf (type inf.Dec) implements "infinite-precision" decimal arithmetic.
"Infinite precision" describes two characteristics: practically unlimited
precision for decimal number representation and no support for calculating
with any specific fixed precision.
Although there is no practical limit on precision,
inf.Dec can only represent finite decimals.

This package is currently in experimental stage and the API may change.

%if 0%{?with_devel}
%package devel
Summary:        %{summary}

%if 0%{?with_check}
%endif

Provides:       golang(speter.net/go/exp/math/dec/inf) = %{version}-%{release}

%description devel
Package inf (type inf.Dec) implements "infinite-precision" decimal arithmetic.
"Infinite precision" describes two characteristics: practically unlimited
precision for decimal number representation and no support for calculating
with any specific fixed precision.
Although there is no practical limit on precision,
inf.Dec can only represent finite decimals.

This package is currently in experimental stage and the API may change.

This package contains library source intended for 
building other packages which use speter.net/go/exp/math/dec/inf.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n exp.%{repo}-%{shortrev}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.$ext" \! -iname "*_test.go") ; do
      install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
      cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
      echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%ifarch 0%{?gccgo_arches}
function gotest { %{gcc_go_test} "$@"; }
%else
%if 0%{?golang_test:1}
function gotest { %{golang_test} "$@"; }
%else
function gotest { go test "$@"; }
%endif
%endif

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
go test %{import_path}
%endif

%if 0%{?with_devel}
%files devel
%copying LICENSE
%{gopath}/src/%{import_path}/
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%copying LICENSE
%endif

%changelog
* Wed Aug 19 2015 jchaloup <jchaloup@redhat.com> - 0-0.3.hg42ca6cd68aa9
- Update spec file to spec-2.0
  resolves: #1250518

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.2.hg42ca6cd68aa9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Jan 12 2015 jchaloup <jchaloup@redhat.com> - 0-0.1.hg42ca6cd68aa9
- First package for Fedora
  resolves: #1181212

